package aero.sita.lab.thack.ise.tourcms;

import java.io.IOException;
import java.net.URLEncoder;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

import org.apache.commons.codec.binary.Base64;

/**
 * 
 * @author Andy.Malinofsky
 * 
 * $string_to_sign = trim($channel."/".$this->marketp_id."/".$verb."/".$outbound_time.$path);
 * $signature = rawurlencode(base64_encode((hash_hmac("sha256", utf8_encode($string_to_sign), $this->private_key, TRUE ))));
 */

public class SignatureGenerator {

   private static String Marketplace_Partner_ID = "";
   private static String API_Private_Key = "";

   public String encode(String path, String verb, String channel, long time) throws NoSuchAlgorithmException, IOException, InvalidKeyException {
      String toSign = new String(channel+"/"+Marketplace_Partner_ID+"/"+verb+"/"+(String.valueOf(time/1000))+path);
      Mac mac = Mac.getInstance("HmacSha256");
      SecretKeySpec secret = new SecretKeySpec(API_Private_Key.getBytes("UTF-8"), "HmacSha256");
      mac.init(secret);
      byte[] shaDigest = mac.doFinal(toSign.getBytes("UTF-8"));
      String result =  new String(Base64.encodeBase64(shaDigest));
      return URLEncoder.encode(result, "UTF-8");
   }
   
   /**
    * test
    * @param args
    */
   public static void main(String[] args) {
      SignatureGenerator sg = new SignatureGenerator();
      try {
         System.out.println(sg.encode("/p/getTours", "GET", "0", System.currentTimeMillis()));
      }
      catch (Exception e) {
         e.printStackTrace();
      }
     
   }
}